# ppg

A Flutter plugin to access the PPG sensor.

This plugin is a modification of [sensors](https://pub.dev/packages/sensors).
I have tested it to read the PPG sensor in WearOS with both
a Fossil Sport and a Fossil Gen 5 Carlyle.
This plugin only supports Android. I don't know if it is even possible to read
the raw PPG data from WatchOS yet.
Both of the WearOS watches I tested with had the sensor `com.google.wear.sensor.ppg`.
This plugin will detect a PPG sensor if it's name contains the string `ppg`

## Usage

To use this plugin, add `ppg` as a [dependency in your pubspec.yaml
file].

This will expose `PPGEvent`s through a `BroadcastStream`

### Example

```dart
import 'package:ppg/ppg.dart';

ppgEvents.listen((PPGEvent event) {
  print(event);
});
// [PPGEvent (x: [0.0, 0.0] t: 0.0)]

```

Also see the `example` subdirectory for an example application that uses
ppg data.
